

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################
#
## name_update.py
#
#  Save (in RAM) your name in dict with name, rank
#
#############################################################################

import GameLogic as gl

players_data = gl.players_data
name = gl.name
local_ip = gl.local_ip
where = gl.where
goal = gl.goal
level = gl.level
my_name = gl.my_name
ranked = gl.ranked

# Get scenes
scenes = gl.getSceneList()

def main():
    name_update(players_data, level, name, my_name, scenes, ranked)
    if gl.tp == 10:
        name_reset()

def name_reset():
    name = {}
    gl.name = name

def name_update(players_data, level, name, my_name, scenes, ranked):
    ### Find my rank with score and get rank of other players in players_data

    # name[NAME] = RANK
    # players_data = ['192.168.1.5','/ball',7,6,'/bat',9,0,'/score',10,'/name','qdffsdc','/rank',1]
    # name = {'kk': 1, 'yoyo': 4, 'toto': 0, 'labomedia': 0}
    if level != 1:
        for scn in scenes :
            if "_players" in scn.name :
                for p in range(level):
                    if players_data != []:
                        # For other players
                        if players_data[p][10] != my_name :
                            name[players_data[p][10]] = players_data[p][12]

                        # For me
                        else:
                            if goal[where]["score"] > 0:
                                name[my_name] = 0
                            if goal[where]["score"] == 0:
                                #if not ranked :
                                ## What are actual rank ?
                                actual_ranked = []
                                # Browse name dictionary
                                for key, value in name.items():
                                    if key != my_name:
                                        if value != 0:
                                            actual_ranked.append(value)
                                actual_ranked.sort()
                                #
                                if actual_ranked == []:
                                    my_rank = level
                                else:
                                    my_rank = actual_ranked[0] - 1

                                name[my_name] = my_rank

    # level = 1, but 2 players, me and machine
    # Get goal[1] score and added fictive player in name: {machine: score}
    if level == 1:
        for scn in scenes :
            if "_players" in scn.name :
                if players_data != []:
                    #print(name)
                    # Set machine
                    if goal[1]["score"] != 0 :
                        name["machine"] = 0
                    else :
                        # Get rank of the machine
                        name["machine"] = 2

                    # For me
                    if goal[where]["score"] > 0:
                        name[my_name] = 0
                    if goal[where]["score"] == 0:
                        #if not ranked :
                        ## What are actual rank ?
                        actual_ranked = []
                        # Browse name dictionary
                        for key, value in name.items():
                            if key != my_name:
                                if value != 0:
                                    actual_ranked.append(value)
                        actual_ranked.sort()

                        if actual_ranked == []:
                            my_rank = 2
                        else:
                            my_rank = 1

                        name[my_name] = my_rank
                            #ranked = True



    # Save in gl
    gl.name = name

main()
