

#############################################################################
# Copyright (C) Labomedia May 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 2
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franproplin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################
#
## rank_display.py
#
#  This script run every 5 frames and display rank if the player loose
#
#############################################################################

import GameLogic as gl

# List of list
players_data = gl.players_data

# Get some variable in GameLogic
level = gl.level
ball = gl.ball
bat = gl.bat
goal = gl.goal
name = gl.name
# My position in list
where = gl.where

# Get scenes
scenes = gl.getSceneList()

# name = {'toto': 3, 'labomedia': 2, 'gddgsg': 0}

# 1.   + "\n\n"
# 2.   + "\n\n"
# 3 .   labomedia  + "\n\n"
# 4 .   toto + "\n\n"

# Get the good scene Rank
for scn in scenes:
    if scn.name == "Rank":

        if level == 1: c = 2 # machine must be display but level = 1 = one player
        else: c = level

        # Create a list with level items
        text_list = [0] * c # example c=3 set 0, 0, 0

        a = 0
        b = 0

        # Create parts of text
        for key, value in name.items():
            if value == 0:
                # Text is empty only rank
                text_list[a] = str(a+1) + ".  \n\n"
                a += 1

        for key, value in name.items():
            if value != 0:
                # Text with rank and name
                b += 1
                text_list[value - 1] = str(value) + " .   " + key + "\n\n"

        # Integral text to display, add string from list
        text = ""
        for b in range(c):
            text = text + str(text_list[b])

        ##if level == 1:
            ### Create a list with 2 items
            ##text_list = [0, 0]
            ### name = {'machine': 2, 'toto': 0}
            ##a = 0
            ##b = 0
            ### Create parts of text
            ##for key, value in name.items():
                ##if value == 0:
                    ### Text is empty only rank
                    ##text_list[a] = str(a+1) + ".  \n\n"
                    ##a += 1
##
            ##for key, value in name.items():
                ##if value != 0:
                    ### Text with rank and name
                    ##b += 1
                    ##text_list[value - 1] = str(value) + " .   " + key + "\n\n"
##
            ### Integral text to display, add string from list
            ##text = ""
            ##for b in range(2):
                ##text = text + str(text_list[b])

        ## To access text prop and display apply Text property
        for obj in scn.objects:
            if str(obj) == "Rank":
                rank_obj = obj
                rank_obj["Text"] = text

