#! /usr/bin/env python3

#####################################################################################################
# ------------- # verif calcul classement # --------------------------------------------------------#

from time import sleep

sleep(0.1)

name = {    "j1": 0,
            "j2": 0,
            "j3": 0,
            "j4": 5,
            "j5": 0 }

my_name = "j5"

players_data1 = [   ['192.168.1.5', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j1', '/rank', 0],
                    ['192.168.1.6', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j2', '/rank', 0],
                    ['192.168.1.7', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j3', '/rank', 0],
                    ['192.168.1.8', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j4', '/rank', 0],
                    ['192.168.1.6', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j5', '/rank', 0]]

players_data2 = [   ['192.168.1.5', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j1', '/rank', 3],
                    ['192.168.1.6', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j2', '/rank', 0],
                    ['192.168.1.7', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j3', '/rank', 5],
                    ['192.168.1.8', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j4', '/rank', 4],
                    ['192.168.1.6', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j5', '/rank', 0]]

players_data3 = [   ['192.168.1.5', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j1', '/rank', 2],
                    ['192.168.1.6', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j2', '/rank', 3],
                    ['192.168.1.7', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j3', '/rank', 5],
                    ['192.168.1.8', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j4', '/rank', 4],
                    ['192.168.1.6', '/ball', 7, 6,  '/bat', 9, 0, '/score', 10, '/name', 'j5', '/rank', 0]]

# recherche des classements des autres
# parcours de players_data pour trouver les "rank" des autres donc pas de moi
def calcul_rank_des_autres(name, players_data):
    # maj des autres
    for i in range(len(players_data)):
        if players_data[i][10] != my_name:
            NAME = players_data[i][10]
            RANK = players_data[i][12]
            name[NAME] = RANK

def calcul_mon_rank(name):
    # qui est different de 0 dans name sauf moi
    ranky = []
    # parcours de name
    print("name", name)
    for key, value in name.items():
        if key != my_name:
            if value != 0:
                ranky.append(value)
    ranky.sort()
    print("ranky", ranky)
    if ranky != []:
        mon_rank = ranky[0] - 1
    else:
        mon_rank = 5
    print("mon_rank", mon_rank)


# main
calcul_rank_des_autres(name, players_data1)
calcul_mon_rank(name)
print ("name1",name)
print
print

calcul_rank_des_autres(name, players_data2)
calcul_mon_rank(name)
print("name2",name)
print
print

calcul_rank_des_autres(name, players_data3)
calcul_mon_rank(name)
print("name3",name)




import GameLogic as gl
from OSC3.OSC import OSCClient, OSCMessage

level = gl.level
my_name = gl.my_name
name = gl.name

# Get all scenes
scenes = gl.getSceneList()

addr_out = gl.local_ip, gl.port_out
clt = OSCClient()
clt.connect(addr_out)

def send_message(title, message):
    m = OSCMessage(title)
    m.append(message)
    try:
        clt.send(m)
        print(m)
    except:
        pass

# Create msg with good datas or this player
m1 = OSCMessage("/player_data")

# Default value
score = [7]
bat_loc = [-8.25, 6.37]
ball_loc = [0, 0]

# My rank
try:
    rank = name[my_name]
except:
    rank = 0

for scen in scenes:
    for obj in scen.objects:
        # Ball
        if "ball" in str(obj) :
            ball_loc = [obj.localPosition[0], obj.localPosition[1]]
        # Bat and score
        if "activ" in obj :
            if obj["activ"] == 1:
                if "goal" in str(obj) :
                    score = obj["score"]
                if "bat" in str(obj) :
                    bat_loc = [obj.localPosition[0], obj.localPosition[1]]
        # Text SendOSC
        if str(obj) == "SendOSC":
            gl.sendosc = obj

m1.append([ '/ball', ball_loc, '/bat', bat_loc, '/score', score,
            '/name', my_name, '/rank', rank])
try:
    clt.send(m1)
except:
    pass

# Quit
if gl.sendosc["quit"]:
    send_message('/quit', 1)

# Reset
if gl.sendosc["reset"]:
    send_message('/reset', 1)

# New Game
if gl.sendosc["new_game"]:
    send_message('/new_game', 1)









































######################################################################################
# verif text classemnt

##name = {'moi': 4, 'labo': 3, 'media': 0, 'serge': 6, 'gerard': 5, 'depardieu': 0}
##level = 6
##
### verif de name
##verif = []
##for key, value in name.items():
    ##if len(name) != level:
        ##print("peu probable")
    ##if value == level:
        ##print("le dernier existe")
    ##verif.append(value)
    ##verif.sort()
##print("verif", verif)
##
### Create a list with level items
##text_list = [0] * level # len = 3 soit 0, 1, 2
##
##a = 0
##b = 0
##
##for key, value in name.items():
    ##if value == 0:
        ##text_list[a] = str(a) + ".  \n\n"
        ##a+= 1
        ##print text_list, "\n\n"
##
##for key, value in name.items():
    ##if value != 0:
        ##b+=1
        ##print "b", b
        ##text_list[value - 1] = str(value) + " .   " + key + "\n\n"
        ##print text_list
##
##
##print text_list, "\n\n"
##
##
### Text to display
##text = ""
##for b in range(level):
    ##text = text + str(text_list[b])
##
##print "text"
##print(text)
